<?php
/**
 *
 * @category        modules
 * @package         MiniSlides v1.0
 * @author          Dev4me / Ruud Eisinga
 * @link			https://dev4me.com/modules-snippets/opensource/minislides/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x / WBCE
 * @requirements    PHP 7.2 and higher
 * @version         1.0.0
 * @lastmodified    Februari 10, 2022
 *
 */

if(defined('WB_PATH') == false) { exit("Cannot access this file directly"); }
	

	
$database->query("DROP TABLE IF EXISTS `".TABLE_PREFIX."mod_minislides`");
$mod_simplegal = 'CREATE TABLE IF NOT EXISTS `'.TABLE_PREFIX.'mod_minislides` ('
	. ' `section_id` INT NOT NULL DEFAULT \'0\','
	. ' `page_id` INT NOT NULL DEFAULT \'0\','
	. ' `name` VARCHAR(128) NOT NULL DEFAULT \'\','
	. ' `description` TEXT NOT NULL,'
	. ' `maxsize` INT NOT NULL DEFAULT \'1600\','
	. ' `containerwidth` INT(11) NOT NULL DEFAULT \'0\','
	. ' `ratio` VARCHAR(16) NOT NULL DEFAULT \'4:3\','
	. ' `usearrows` INT(11) NOT NULL DEFAULT \'0\','
	. ' `usepagination` INT(11) NOT NULL DEFAULT \'0\','
	. ' `pauseonhover` INT(11) NOT NULL DEFAULT \'1\','
	. ' `autoplay` INT NOT NULL DEFAULT \'1\','
	. ' `interval` INT NOT NULL DEFAULT \'5\','
	. ' `speed` INT NOT NULL DEFAULT \'300\','
	. ' `class` VARCHAR(128) NOT NULL DEFAULT \'\','
	. ' `transition` VARCHAR(128) NOT NULL DEFAULT \'slide\','
	. ' `sorting` MEDIUMTEXT NULL ,'
	. ' PRIMARY KEY ( `section_id` ) '
	. ' ) COLLATE=\'utf8_general_ci\' ';
$database->query($mod_simplegal);

$database->query("DROP TABLE IF EXISTS `".TABLE_PREFIX."mod_minislidesimg`");
$mod_simplegal_img = 'CREATE TABLE IF NOT EXISTS `'.TABLE_PREFIX.'mod_minislidesimg` ('
	. ' `image_id` INT(11) NOT NULL auto_increment,'
	. ' `section_id` INT NOT NULL DEFAULT \'0\','
	. ' `position` INT(11) NOT NULL DEFAULT \'0\','
	. ' `image` VARCHAR(255) NOT NULL DEFAULT \'\','
	. ' `alt` VARCHAR(255) NOT NULL DEFAULT \'\','
	. ' `title` TEXT NOT NULL,'
	. ' PRIMARY KEY ( `image_id` ) '
	. ' ) COLLATE=\'utf8_general_ci\' ';
$database->query($mod_simplegal_img);

$path = WB_PATH.'/modules/minislides/';
if(file_exists($path.'new_frontend.css')) {
	if(!rename($path.'new_frontend.css',$path.'frontend.css')) {
		echo "<h2>Error renaming frontend.css. Please rename new_frontend.css manually to frontend.css</h2>";
	}
}



?>