<?php
/**
 *
 * @category        modules
 * @package         MiniSlides v1.0
 * @author          Dev4me / Ruud Eisinga
 * @link			https://dev4me.com/modules-snippets/opensource/minislides/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x / WBCE
 * @requirements    PHP 7.2 and higher
 * @version         1.0.0
 * @lastmodified    Februari 10, 2022
 *
 */

if(defined('WB_PATH') == false) { exit("Cannot access this file directly"); }
require(dirname(__FILE__).'/info.php');
$basedir = WB_PATH.MEDIA_DIRECTORY.'/'.$image_path.'/';
$baseurl = WB_URL.MEDIA_DIRECTORY.'/'.$image_path.'/';
require_once (dirname(__FILE__).'/functions.php');
minislides_create_dir($section_id);

if(!file_exists(WB_PATH.'/modules/minislides/languages/'.LANGUAGE.'.php')) {
	require_once(WB_PATH.'/modules/minislides/languages/EN.php');
} else {
	require_once(WB_PATH.'/modules/minislides/languages/'.LANGUAGE.'.php');
}

// Setup template object
$template = new Template(WB_PATH.'/modules/minislides');
$template->set_file('page', 'modify.htt');
$template->set_block('page', 'main_block', 'main');

// Get page content
$query = "SELECT * FROM ".TABLE_PREFIX."mod_minislides WHERE section_id = '$section_id'";
$get_settings = $database->query($query);
$settings = $get_settings->fetchRow();


$name = $settings['name'];
$description = $settings['description'];
$maxsize = $settings['maxsize'];
$ratio = $settings['ratio'];
$class = $settings['class'];
$interval = $settings['interval'];
$autoplay = $settings['autoplay'];
$speed = $settings['speed'];
$transition = $settings['transition'];
$containerwidth = $settings['containerwidth'];
$usearrows = $settings['usearrows'];
$usepagination = $settings['usepagination'];
$pauseonhover = $settings['pauseonhover'];


$upload_limit = minislides_get_upload_limit();
//build images
$imglist = '';
$curdir = $section_id."/";
$imglist = getMiniSlidesImageList($basedir,$curdir,$baseurl,$section_id);
 
$tr = array('slide', 'fade', 'cube', 'coverflow', 'flip', 'cards');
$trselect = '<select name="transition">';
foreach ($tr as $t) {
	$selected = $t == $transition ? " selected='selected'": '';
	$trselect .= '<option value="'.$t.'"'.$selected.'>'.$t.'</option>';
}
$trselect .= '</select>';

$rat = array('none', '1:1', '4:3', '16:9','16:4','21:9','21:4','3:4', '9:16', '9:21');
$ratselect = '<select name="ratio">';
foreach ($rat as $t) {
	$selected = $t == $ratio ? " selected='selected'": '';
	$ratselect .= '<option value="'.$t.'"'.$selected.'>'.$t.'</option>';
}
$ratselect .= '</select>';


// Insert vars
$template->set_var(array(
								'PAGE_ID' => $page_id,
								'SECTION_ID' => $section_id,
								'WB_URL' => WB_URL,
								'NAME' => $name,
								'DESCRIPTION' => $description,
								'MAXSIZE' => $maxsize,
								'RATIO' => $ratselect,
								'CLASS' => $class,
								'TRANSITION' => $trselect,
								'AUTOPLAY' => $autoplay?"checked='checked'":"",
								'INTERVAL' => $interval,
								'SPEED' => $speed,
								'CONTAINERWIDTH' => $containerwidth,
								'USEARROWS' => $usearrows?"checked='checked'":"",
								'USEPAGINATION' => $usepagination?"checked='checked'":"",
								'PAUSEONHOVER' => $pauseonhover?"checked='checked'":"",

								'TEXT_DRAGDROP' => $MG['DRAGDROP'],
								'TEXT_REFRESH' => $MG['REFRESH'],
								'TEXT_DELETEALL' => $MG['DELETEALL'],
								'TEXT_DELETESURE' => $MG['DELETESURE'],
								'TEXT_DELETEONE' => $MG['DELETEONE'],
								'TEXT_YES' => $MG['YES'],
								'TEXT_NO' => $MG['NO'],
								'TEXT_CAPTION' => $MG['CAPTION'],
								'TEXT_UPLOADLIMIT' => $MG['UPLOADLIMIT'],
								'UPLOAD_LIMIT' => $upload_limit,
								'TEXT_SORT' => $MG['SORT'],
								'TEXT_SAVE' => $TEXT['SAVE'],
								'TEXT_CANCEL' => $TEXT['CANCEL'],
								'TEXT_MINISLIDES' => $MG['MINISLIDES'],
								'TEXT_SETTINGS' => $MG['SETTINGS'],
								'TEXT_UPLOAD' => $MG['UPLOAD'],
								'TEXT_SUBTITLE' => $MG['SUBTITLE'],
								'TEXT_NAME' => $MG['NAME'],
								'TEXT_DESC' => $MG['DESCRIPTION'],
								'TEXT_MAXSIZE' => $MG['MAXSIZE'],
								'TEXT_RATIO' => $MG['RATIOTHUMB'],
								'TEXT_ADDCLASS' => $MG['ADDCLASS'],
								'HELP_NAME' => $MG['HELP_NAME'],
								'HELP_DESC' => $MG['HELP_DESCRIPTION'],
								'HELP_MAXSIZE' => $MG['HELP_MAXSIZE'],
								'HELP_RATIO' => $MG['HELP_RATIO'],
								'HELP_ADDCLASS' => $MG['HELP_ADDCLASS'],
								'NOTE' => $MG['NOTE'],
								'FILE' => $MG['FILE'],
								'CURRENT' => $MG['CURRENT'],
								'REMOVECUR' => $MG['REMOVECUR'],
								'UPLOADING' => $MG['UPLOADING'],
								'IMAGES' => $imglist,
								'TEXT_TRANSITION' => $MG['TRANSITION'],
								'HELP_TRANSITION' => $MG['HELP_TRANSITION'],
								'TEXT_AUTOPLAY' => $MG['AUTOPLAY'],
								'HELP_AUTOPLAY' => $MG['HELP_AUTOPLAY'],
								'TEXT_AUTOPLAY_INT' => $MG['AUTOPLAY_INT'],
								'HELP_AUTOPLAY_INT' => $MG['HELP_AUTOPLAY_INT'],
								'TEXT_CONTAINERWIDTH' => $MG['TEXT_CONTAINERWIDTH'],
								'HELP_CONTAINERWIDTH' => $MG['HELP_CONTAINERWIDTH'],
								'TEXT_SPEED' => $MG['TEXT_SPEED'],
								'HELP_SPEED' => $MG['HELP_SPEED'],
								'TEXT_USEARROWS' => $MG['TEXT_USEARROWS'],
								'HELP_USEARROWS' => $MG['HELP_USEARROWS'],
								'TEXT_USEPAGINATION' => $MG['TEXT_USEPAGINATION'],
								'HELP_USEPAGINATION' => $MG['HELP_USEPAGINATION'],
								'TEXT_PAUSEONHOVER' => $MG['TEXT_PAUSEONHOVER'],
								'HELP_PAUSEONHOVER' => $MG['HELP_PAUSEONHOVER'],
								)
						);

// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

?>