<?php
/**
 *
 * @category        modules
 * @package         MiniSlides v1.0
 * @author          Dev4me / Ruud Eisinga
 * @link			https://dev4me.com/modules-snippets/opensource/minislides/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x / WBCE
 * @requirements    PHP 7.2 and higher
 * @version         1.0.0
 * @lastmodified    Februari 10, 2022
 *
 */

require('../../config.php');
require_once (WB_PATH.'/framework/functions.php');
require_once ('functions.php');
require(WB_PATH.'/modules/admin.php');
$update_when_modified = true; 
set_time_limit ( 600 );
require(dirname(__FILE__).'/info.php');
$basedir = WB_PATH.MEDIA_DIRECTORY.'/'.$image_path.'/';
$baseurl = WB_URL.MEDIA_DIRECTORY.'/'.$image_path.'/';
$pathToFolder = $basedir.$section_id.'/';
$thumbFolder = $pathToFolder.'thumbs/';
$overwrite = true;
$message = '';

if(isset($_POST['section_id'])) {
	$maxsize 		= intval($_POST['maxsize']);
	$class 			= $database->escapeString($_POST['class']);
	$name			= $database->escapeString($_POST['name']);
	$transition 	= $database->escapeString($_POST['transition']);
	$description 	= $database->escapeString($_POST['description']);
	$ratio 			= $database->escapeString($_POST['ratio']);
	$autoplay 		= isset($_POST['autoplay'])?"1":"0";
	$interval 		= intval($_POST['interval']);
	$speed 			= intval($_POST['speed']);
	$containerwidth = intval($_POST['containerwidth']);
	$usearrows 		= isset($_POST['usearrows'])?"1":"0";
	$usepagination 	= isset($_POST['usepagination'])?"1":"0";
	$pauseonhover 	= isset($_POST['pauseonhover'])?"1":"0";
	
	
	
	$query = "UPDATE ".TABLE_PREFIX."mod_minislides SET 
			`name` = '$name', 
			`description` = '$description', 
			`maxsize` = '$maxsize', 
			`ratio` = '$ratio', 
			`class` = '$class', 
			`transition` = '$transition',
			`autoplay` = '$autoplay',
			`interval` = '$interval',
			`speed` = '$speed',
			`containerwidth` = '$containerwidth',
			`usearrows` = '$usearrows',
			`usepagination` = '$usepagination',
			`pauseonhover` = '$pauseonhover'
			WHERE `section_id` = '$section_id'";
	$database->query($query);	

	make_dir($basedir);
	make_dir($pathToFolder);
	make_dir($thumbFolder);
}

// Check if there is a database error, otherwise say successful
if($database->is_error()) {
	$admin->print_error($database->get_error(), $js_back);
} else {
	$admin->print_success($MESSAGE['PAGES_SAVED'], ADMIN_URL.'/pages/modify.php?page_id='.$page_id);
}
// Print admin footer
$admin->print_footer();

?>