<?php
/**
 *
 * @category        modules
 * @package         MiniSlides v1.0
 * @author          Dev4me / Ruud Eisinga
 * @link			https://dev4me.com/modules-snippets/opensource/minislides/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x / WBCE
 * @requirements    PHP 7.2 and higher
 * @version         1.0.0
 * @lastmodified    Februari 10, 2022
 *
 */

// https://swiperjs.com/swiper-api#parameters

if(defined('WB_PATH') == false) { exit("Cannot access this file directly"); }
require(dirname(__FILE__).'/info.php');
$basedir = WB_PATH.MEDIA_DIRECTORY.'/'.$image_path.'/';
$baseurl = WB_URL.MEDIA_DIRECTORY.'/'.$image_path.'/';
require_once (dirname(__FILE__).'/functions.php');

$get_settings = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_minislides WHERE section_id = '$section_id'");
$settings = $get_settings->fetchRow();
$autoplay = $settings['autoplay'];
$interval = $settings['interval'];
if($interval == 0) $interval = 5;
$speed = $settings['speed'];
$pause = $settings['pauseonhover'];
if($speed == 0) $speed = 300;
$name = $settings['name'];
$description = nl2br($settings['description']);
$transition = $settings['transition'];
$arrows = $settings['usearrows'];
$pages = $settings['usepagination'];
$width = $settings['containerwidth'];
$width = $width ? ' style="margin-left:auto;margin-right:auto;max-width:'.$width.'px"':'';

$class = $settings['class'];
$class = $class ? ' '.$class:'';

$sorting = ($settings['sorting']);
$maxsize = ($settings['maxsize']);
$ratio = $settings['ratio'];
$curdir = $section_id."/";


$images = getMiniSlidesImages($basedir,$curdir,$section_id,$sorting); 
if($images) {
	echo '<div class="minislides sec'.$section_id.$class.'"'.$width.'>'; 
	if ($name) echo '<h1 class="mgtitle">'.$name.'</h1>';
	if ($description) echo '<div class="msdescription">'.$description.'</div>';
	echo '<div class="swiper">'; 
	echo '<div class="swiper-wrapper">';
	foreach($images as $img) { 
		$timestamp = md5(filectime($basedir.$img['file']));
		echo '<div class="swiper-slide">';
		echo '<img class="swiper-img" src="'.str_replace(' ','%20',$baseurl.$curdir.basename($img['file'])).'?nc='.$timestamp.'">'; 
		if($img['caption']) echo '<div class="swiper-caption">'.htmlentities(nl2br($img['caption'])).'</div>';			
		echo '  </div>'; 
	}
	echo '</div>'; 
	if($arrows) {
		echo '<div class="swiper-button-prev"></div>';
		echo '<div class="swiper-button-next"></div>';
	} 
	if($pages) echo '<div class="swiper-pagination"></div>';
	echo "</div>"; 
	echo "</div>\n"; 
}
?>
<script>
new Swiper('.sec<?=$section_id?> .swiper',{
<?php if($pages) { ?>	pagination: {	el: ".swiper-pagination", clickable: true, }, <?php } ?>
<?php if($arrows) { ?>	navigation: { nextEl: '.swiper-button-next',	prevEl: '.swiper-button-prev', }, <?php } ?>
	keyboard: { enabled: true, onlyInViewport: true,},
<?php if($autoplay) {?>	autoplay: {	delay: <?=$interval?>000,disableOnInteraction: false,<?php if($pause) { ?>pauseOnMouseEnter: true,<?php } ?>},<?php } ?>
    speed: <?=$speed?>,
    effect: '<?=$transition?>',
	watchOverflow: true,
	fadeEffect: {
		crossFade: true
	},
    <?php if(count($images)> 1) { ?>loop: true,<?php } ?>
});

</script>